#include <eikapp.h>
#include <e32base.h>
#include <sdlapp.h>
#include <eikenv.h>
#include <eikappui.h>
#include <eikapp.h>

class CROTTApp : public CSDLApp {
public:
	CROTTApp();
	~CROTTApp();
#if defined (UIQ3)
	/**
	 * Returns the resource id to be used to declare the views supported by this UIQ3 app
	 * @return TInt, resource id
	 */
	TInt ViewResourceId();
#endif
	TUid AppDllUid() const;

};




#ifdef EPOC_AS_APP

// this function is called automatically by the SymbianOS to deliver the new CApaApplication object
#if !defined (UIQ3) && !defined (S60V3)
EXPORT_C 
#endif
CApaApplication* NewApplication() {
	return new CROTTApp;
}

#if defined (UIQ3) || defined (S60V3)
#include <eikstart.h>
// E32Main() contains the program's start up code, the entry point for an EXE.
GLDEF_C TInt E32Main() {
 	return EikStart::RunApplication(NewApplication);
}
#endif

#endif // EPOC_AS_APP

#if !defined (UIQ3) && !defined (S60V3)
GLDEF_C  TInt E32Dll(TDllReason) {
	return KErrNone;
}
#endif

CROTTApp::CROTTApp() {
}

CROTTApp::~CROTTApp() {
}

#if defined (UIQ3)
#include <ROTT.rsg>
/**
 * Returns the resource id to be used to declare the views supported by this UIQ3 app
 * @return TInt, resource id
 */
TInt CROTTApp::ViewResourceId() {
	return R_SDL_VIEW_UI_CONFIGURATIONS;
}
#endif

/**
 *   Responsible for returning the unique UID of this application
 * @return unique UID for this application in a TUid
 **/
TUid CROTTApp::AppDllUid() const {
	return TUid::Uid(0xA000A008);
}

extern "C" char GetDataDrive()
{
	TFileName filename = CEikonEnv::Static()->EikAppUi()->Application()->ResourceFileName();
	TParsePtrC parser(filename);
	return parser.Drive()[0];
}
// make this easily available everywhere
extern "C" char* GetExecutablePath()
{
	return CSDLApp::GetExecutablePathCStr();	
}
/////////////////////////////////////////////////////////////////////////////////////////////////


